Index: src/language/data-io/list.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/list.q,v
retrieving revision 1.21
diff -u -p -r1.21 list.q
--- src/language/data-io/list.q	25 Nov 2006 02:15:01 -0000	1.21
+++ src/language/data-io/list.q	5 Dec 2006 06:36:40 -0000
@@ -213,12 +213,12 @@ cmd_list (struct lexer *lexer, struct da
   if (cmd.numbering == LST_NUMBERED)
     {
       /* Initialize the case-number variable. */
-      strcpy (casenum_var.name, "Case#");
-      casenum_var.type = NUMERIC;
+      int width = cmd.last == LONG_MAX ? 5 : intlog10 (cmd.last);
+      struct fmt_spec format = fmt_for_output (FMT_F, width, 0);
+      var_set_name (&casenum_var, "Case#");
+      casenum_var.width = 0;
       casenum_var.fv = -1;
-      casenum_var.print = fmt_for_output (FMT_F,
-                                          (cmd.last == LONG_MAX
-                                           ? 5 : intlog10 (cmd.last)), 0);
+      var_set_both_formats (&casenum_var, &format);
 
       /* Add the weight variable at the beginning of the variable list. */
       cmd.n_variables++;
@@ -266,7 +266,7 @@ write_all_headers (const struct ccase *c
 
 	    for (i = 0; i < cmd.n_variables; i++)
 	      fprintf (x->file, "    <TH><EM>%s</EM></TH>\n",
-		       cmd.v_variables[i]->name);
+		       var_get_name (cmd.v_variables[i]));
 	  }
 
 	  fputs ("  </TR>\n", x->file);
@@ -313,12 +313,15 @@ write_header (struct outp_driver *d)
       for (i = x = 0; i < prc->n_vertical; i++)
 	{
 	  struct variable *v = cmd.v_variables[i];
+          const char *name = var_get_name (v);
+          size_t name_len = strlen (name);
+          const struct fmt_spec *print = var_get_print_format (v);
 	  size_t j;
 
-	  memset (&prc->header[prc->header_rows - 1][x], '-', v->print.w);
-	  x += v->print.w - 1;
-	  for (j = 0; j < strlen (v->name); j++)
-	    prc->header[strlen (v->name) - j - 1][x] = v->name[j];
+	  memset (&prc->header[prc->header_rows - 1][x], '-', print->w);
+	  x += print->w - 1;
+	  for (j = 0; j < name_len; j++)
+	    prc->header[name_len - j - 1][x] = name[j];
 	  x += 2;
 	}
 
@@ -326,13 +329,16 @@ write_header (struct outp_driver *d)
       for (; i < cmd.n_variables; i++)
 	{
 	  struct variable *v = cmd.v_variables[i];
+          const char *name = var_get_name (v);
+          size_t name_len = strlen (name);
+          const struct fmt_spec *print = var_get_print_format (v);
 	  
 	  memset (&prc->header[prc->header_rows - 1][x], '-',
-		  MAX (v->print.w, (int) strlen (v->name)));
-	  if ((int) strlen (v->name) < v->print.w)
-	    x += v->print.w - strlen (v->name);
- 	  memcpy (&prc->header[0][x], v->name, strlen (v->name));
-	  x += strlen (v->name) + 1;
+		  MAX (print->w, (int) name_len));
+	  if ((int) name_len < print->w)
+	    x += print->w - name_len;
+ 	  memcpy (&prc->header[0][x], name, name_len);
+	  x += name_len + 1;
 	}
 
       /* Add null bytes. */
@@ -466,7 +472,7 @@ write_fallback_headers (struct outp_driv
 
 	entry:
 	  {
-	    int var_width = cmd.v_variables[index]->print.w;
+	    int var_width = var_get_print_format (cmd.v_variables[index])->w;
 	    if (width + var_width > max_width && width != 0)
 	      {
 		width = 0;
@@ -480,7 +486,7 @@ write_fallback_headers (struct outp_driv
 	  {
 	    char varname[LONG_NAME_LEN + 2];
 	    snprintf (varname, sizeof varname,
-                      " %s", cmd.v_variables[index]->name);
+                      " %s", var_get_name (cmd.v_variables[index]));
 	    write_varname (d, varname, leader_width);
 	  }
 	}
@@ -546,7 +552,9 @@ determine_layout (void)
       for (width = cmd.n_variables - 1, column = 0; column < cmd.n_variables; column++)
 	{
 	  struct variable *v = cmd.v_variables[column];
-	  width += MAX (v->print.w, (int) strlen (v->name));
+          int fmt_width = var_get_print_format (v)->w;
+          int name_len = strlen (var_get_name (v));
+	  width += MAX (fmt_width, name_len);
 	}
       if (width <= max_width)
 	{
@@ -560,9 +568,11 @@ determine_layout (void)
 	   column++) 
         {
           struct variable *v = cmd.v_variables[column];
-          width += v->print.w;
-          if (strlen (v->name) > height)
-            height = strlen (v->name);
+          int fmt_width = var_get_print_format (v)->w;
+          size_t name_len = strlen (var_get_name (v));
+          width += fmt_width;
+          if (name_len > height)
+            height = name_len;
         }
       
       /* If it fit then we need to determine how many labels can be
@@ -575,9 +585,9 @@ determine_layout (void)
 	  for (column = cmd.n_variables; column-- != 0; )
 	    {
 	      struct variable *v = cmd.v_variables[column];
-	      int trial_width = (width - v->print.w
-				 + MAX (v->print.w, (int) strlen (v->name)));
-	      
+              int name_len = strlen (var_get_name (v));
+              int fmt_width = var_get_print_format (v)->w;
+	      int trial_width = width - fmt_width + MAX (fmt_width, name_len);
 	      if (trial_width > max_width)
 		{
 		  prc->n_vertical = column + 1;
@@ -591,9 +601,12 @@ determine_layout (void)
 	  /* Finally determine the length of the headers. */
 	  for (prc->header_rows = 0, column = 0;
 	       column < prc->n_vertical;
-	       column++)
-	    prc->header_rows = MAX (prc->header_rows,
-				    strlen (cmd.v_variables[column]->name));
+	       column++) 
+            {
+              struct variable *var = cmd.v_variables[column];
+              size_t name_len = strlen (var_get_name (var));
+              prc->header_rows = MAX (prc->header_rows, name_len); 
+            }
 	  prc->header_rows++;
 	  continue;
 	}
@@ -630,19 +643,24 @@ list_cases (const struct ccase *c, void 
 
 	if (!prc->header_rows)
 	  {
-	    ds_put_format(&line_buffer, "%8s: ", cmd.v_variables[0]->name);
+	    ds_put_format(&line_buffer, "%8s: ",
+                          var_get_name (cmd.v_variables[0]));
 	  }
 	
       
 	for (column = 0; column < cmd.n_variables; column++)
 	  {
 	    struct variable *v = cmd.v_variables[column];
+            const struct fmt_spec *print = var_get_print_format (v);
 	    int width;
 
-	    if (prc->type == 0 && column >= prc->n_vertical)
-	      width = MAX ((int) strlen (v->name), v->print.w);
+	    if (prc->type == 0 && column >= prc->n_vertical) 
+              {
+                int name_len = strlen (var_get_name (v));
+                width = MAX (name_len, print->w); 
+              }
 	    else
-	      width = v->print.w;
+	      width = print->w;
 
 	    if (width + ds_length(&line_buffer) > max_width && 
 		ds_length(&line_buffer) != 0)
@@ -657,27 +675,23 @@ list_cases (const struct ccase *c, void 
 		ds_clear(&line_buffer);
 
 		if (!prc->header_rows)
-		  {
-		    ds_put_format (&line_buffer, "%8s: ", v->name);
-		  }
+                  ds_put_format (&line_buffer, "%8s: ", var_get_name (v));
 	      }
 
-	    if (width > v->print.w)
-	      {
-		ds_put_char_multiple(&line_buffer, ' ', width - v->print.w);
-	      }
+	    if (width > print->w)
+              ds_put_char_multiple(&line_buffer, ' ', width - print->w);
 
-            if (fmt_is_string (v->print.type) || v->fv != -1)
+            if (fmt_is_string (print->type) || v->fv != -1)
 	      {
-                data_out (case_data (c, v->fv), &v->print,
-                          ds_put_uninit (&line_buffer, v->print.w));
+                data_out (case_data (c, v->fv), print,
+                          ds_put_uninit (&line_buffer, print->w));
 	      }
             else 
               {
                 union value case_idx_value;
                 case_idx_value.f = case_idx;
-                data_out (&case_idx_value, &v->print,
-                          ds_put_uninit (&line_buffer,v->print.w)); 
+                data_out (&case_idx_value, print,
+                          ds_put_uninit (&line_buffer,print->w)); 
               }
 
 	    ds_put_char(&line_buffer, ' ');
@@ -702,19 +716,20 @@ list_cases (const struct ccase *c, void 
 	for (column = 0; column < cmd.n_variables; column++)
 	  {
 	    struct variable *v = cmd.v_variables[column];
+            const struct fmt_spec *print = var_get_print_format (v);
 	    char buf[256];
 	    
-            if (fmt_is_string (v->print.type) || v->fv != -1)
-	      data_out (case_data (c, v->fv), &v->print, buf);
+            if (fmt_is_string (print->type) || v->fv != -1)
+	      data_out (case_data (c, v->fv), print, buf);
             else 
               {
                 union value case_idx_value;
                 case_idx_value.f = case_idx;
-                data_out (&case_idx_value, &v->print, buf);
+                data_out (&case_idx_value, print, buf);
               }
 
             fputs ("    <TD>", x->file);
-            html_put_cell_contents (d, TAB_FIX, ss_buffer (buf, v->print.w));
+            html_put_cell_contents (d, TAB_FIX, ss_buffer (buf, print->w));
             fputs ("</TD>\n", x->file);
 	  }
 	  
Index: src/language/data-io/matrix-data.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/matrix-data.c,v
retrieving revision 1.19
diff -u -p -r1.19 matrix-data.c
--- src/language/data-io/matrix-data.c	25 Nov 2006 02:15:01 -0000	1.19
+++ src/language/data-io/matrix-data.c	5 Dec 2006 06:36:42 -0000
@@ -610,7 +610,7 @@ cmd_matrix_data (struct lexer *lexer, st
 	int type = mv->var_type;
 	
 	assert (type >= 0 && type < MXD_COUNT);
-	v->print = v->write = fmt_tab[type];
+        var_set_both_formats (v, &fmt_tab[type]);
 
 	if (type == MXD_CONTINUOUS)
 	  mx->n_continuous++;
@@ -1085,7 +1085,7 @@ nr_read_data_lines (struct nr_aux_data *
 	    if (token.type != MNUM)
 	      {
 		msg (SE, _("expecting value for %s %s"),
-		     dict_get_var (nr->dict, j)->name,
+		     var_get_name (dict_get_var (nr->dict, j)),
                      context (mx->reader));
 		return 0;
 	      }
@@ -1260,7 +1260,7 @@ nr_read_splits (struct nr_aux_data *nr, 
         {
           msg (SE, _("Expecting value %g for %s."),
                nr->split_values[i],
-               dict_get_split_vars (nr->dict)[i]->name);
+               var_get_name (dict_get_split_vars (nr->dict)[i]));
           return false;
         }
     }
@@ -1310,7 +1310,7 @@ nr_read_factors (struct nr_aux_data *nr,
 	  {
 	    msg (SE, _("Syntax error expecting value %g for %s %s."),
 		 nr->factor_values[i + mx->n_factors * cell],
-		 mx->factors[i]->name, context (mx->reader));
+		 var_get_name (mx->factors[i]), context (mx->reader));
 	    return false;
 	  }
       }
@@ -1354,8 +1354,8 @@ dump_cell_content (const struct dictiona
 	  }
 	if (type == 1)
 	  buf_copy_str_rpad (case_data_rw (c, mx->varname_->fv)->s, 8,
-                             dict_get_var (dict,
-                                           mx->first_continuous + i)->name);
+                             var_get_name (
+                               dict_get_var (dict, mx->first_continuous + i)));
 	if (!write_case (wc_data))
           return false;
       }
@@ -1957,7 +1957,8 @@ wr_read_indeps (struct wr_aux_data *wr)
 	if (token.type != MNUM)
 	  {
 	    msg (SE, _("Syntax error expecting value for %s %s."),
-                 dict_get_var (wr->dict, mx->first_continuous + j)->name,
+                 var_get_name (dict_get_var (wr->dict,
+                                             mx->first_continuous + j)),
                  context (mx->reader));
 	    return false;
 	  }
Index: src/language/data-io/print.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/print.c,v
retrieving revision 1.20
diff -u -p -r1.20 print.c
--- src/language/data-io/print.c	11 Nov 2006 23:10:00 -0000	1.20
+++ src/language/data-io/print.c	5 Dec 2006 06:36:42 -0000
@@ -334,7 +334,9 @@ parse_variable_argument (struct lexer *l
       for (i = 0; i < var_cnt; i++) 
         {
           struct variable *v = vars[i];
-          formats[i] = which_formats == PRINT ? v->print : v->write; 
+          formats[i] = (which_formats == PRINT
+                        ? *var_get_print_format (v)
+                        : *var_get_write_format (v));
         }
       add_space = which_formats == PRINT;
     }
@@ -347,7 +349,7 @@ parse_variable_argument (struct lexer *l
         struct prt_out_spec *spec;
 
         var = vars[var_idx++];
-        if (!fmt_check_width_compat (f, var->width))
+        if (!fmt_check_width_compat (f, var_get_width (var)))
           return false;
 
         spec = pool_alloc (trns->pool, sizeof *spec);
@@ -363,7 +365,7 @@ parse_variable_argument (struct lexer *l
            filled with spaces, instead of using the normal format
            that usually contains a period. */ 
         spec->sysmis_as_spaces = (which_formats == WRITE
-                                  && var->type == NUMERIC
+                                  && var_is_numeric (var)
                                   && (fmt_get_category (spec->format.type)
                                       != FMT_CAT_BINARY));
 
@@ -410,7 +412,7 @@ dump_table (struct print_trns *trns, con
           width = ds_length (&spec->string);
           break;
         case PRT_VAR:
-          tab_text (t, 0, row, TAB_LEFT, spec->var->name);
+          tab_text (t, 0, row, TAB_LEFT, var_get_name (spec->var));
           tab_text (t, 3, row, TAB_LEFT | TAB_FIX,
                     fmt_to_string (&spec->format, fmt_string));
           width = spec->format.w;
Index: src/language/dictionary/apply-dictionary.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/apply-dictionary.c,v
retrieving revision 1.10
diff -u -p -r1.10 apply-dictionary.c
--- src/language/dictionary/apply-dictionary.c	11 Nov 2006 23:10:00 -0000	1.10
+++ src/language/dictionary/apply-dictionary.c	5 Dec 2006 06:36:42 -0000
@@ -63,60 +63,66 @@ cmd_apply_dictionary (struct lexer *lexe
   for (i = 0; i < dict_get_var_cnt (dict); i++)
     {
       struct variable *s = dict_get_var (dict, i);
-      struct variable *t = dict_lookup_var (dataset_dict (ds), s->name);
+      struct variable *t = dict_lookup_var (dataset_dict (ds),
+                                            var_get_name (s));
       if (t == NULL)
 	continue;
 
       n_matched++;
-      if (s->type != t->type)
+      if (var_get_type (s) != var_get_type (t))
 	{
 	  msg (SW, _("Variable %s is %s in target file, but %s in "
 		     "source file."),
-	       s->name,
-	       t->type == ALPHA ? _("string") : _("numeric"),
-	       s->type == ALPHA ? _("string") : _("numeric"));
+	       var_get_name (s),
+	       var_is_alpha (t) ? _("string") : _("numeric"),
+	       var_is_alpha (s) ? _("string") : _("numeric"));
 	  continue;
 	}
 
-      if (s->label && strcspn (s->label, " ") != strlen (s->label))
-	{
-	  free (t->label);
-	  t->label = s->label;
-	  s->label = NULL;
-	}
-
-      if (val_labs_count (s->val_labs) && t->width > MAX_SHORT_STRING)
+      if (var_get_label (s))
+        {
+          const char *label = var_get_label (s);
+          if (strcspn (label, " ") != strlen (label))
+            var_set_label (t, label);
+        }
+      
+      if (val_labs_count (s->val_labs) && var_is_long_string (t))
 	msg (SW, _("Cannot add value labels from source file to "
 		   "long string variable %s."),
-	     s->name);
+	     var_get_name (s));
       else if (val_labs_count (s->val_labs))
 	{
-          if (val_labs_can_set_width (s->val_labs, t->width))
+          if (val_labs_can_set_width (s->val_labs, var_get_width (t)))
             {
               val_labs_destroy (t->val_labs);
               t->val_labs = s->val_labs;
-              val_labs_set_width (t->val_labs, t->width);
-              s->val_labs = val_labs_create (s->width);
+              val_labs_set_width (t->val_labs, var_get_width (t));
+              s->val_labs = val_labs_create (var_get_width (s));
             }
 	}
 
-      if (!mv_is_empty (&s->miss) && t->width > MAX_SHORT_STRING)
-	msg (SW, _("Cannot apply missing values from source file to "
-		   "long string variable %s."),
-	     s->name);
-      else if (!mv_is_empty (&s->miss))
-	{
-          if (mv_is_resizable (&s->miss, t->width)) 
+      if (var_has_missing_values (s))
+        {
+          if (!var_is_long_string (t))
             {
-              mv_copy (&t->miss, &s->miss);
-              mv_resize (&t->miss, t->width); 
+              struct missing_values miss;
+              mv_copy (&miss, var_get_missing_values (s));
+              if (mv_is_resizable (&miss, var_get_width (t))) 
+                {
+                  mv_resize (&miss, var_get_width (t));
+                  var_set_missing_values (t, &miss);
+                }
             }
-	}
+          else
+            msg (SW, _("Cannot apply missing values from source file to "
+                       "long string variable %s."),
+                 var_get_name (s));
+        }
 
-      if (s->type == NUMERIC)
+      if (var_is_numeric (s))
 	{
-	  t->print = s->print;
-	  t->write = s->write;
+          var_set_print_format (t, var_get_print_format (s));
+          var_set_write_format (t, var_get_write_format (s));
 	}
     }
 
@@ -128,7 +134,8 @@ cmd_apply_dictionary (struct lexer *lexe
   if (dict_get_weight (dict) != NULL) 
     {
       struct variable *new_weight
-        = dict_lookup_var (dataset_dict (ds), dict_get_weight (dict)->name);
+        = dict_lookup_var (dataset_dict (ds),
+                           var_get_name (dict_get_weight (dict)));
 
       if (new_weight != NULL)
         dict_set_weight (dataset_dict (ds), new_weight);
Index: src/language/dictionary/formats.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/formats.c,v
retrieving revision 1.13
diff -u -p -r1.13 formats.c
--- src/language/dictionary/formats.c	11 Nov 2006 23:10:00 -0000	1.13
+++ src/language/dictionary/formats.c	5 Dec 2006 06:36:42 -0000
@@ -85,7 +85,7 @@ internal_cmd_formats (struct lexer *lexe
 
       if (!parse_variables (lexer, dataset_dict (ds), &v, &cv, PV_NUMERIC))
 	return CMD_FAILURE;
-      type = v[0]->type;
+      type = var_get_type (v[0]);
 
       if (!lex_match (lexer, '('))
 	{
@@ -106,9 +106,9 @@ internal_cmd_formats (struct lexer *lexe
       for (i = 0; i < cv; i++)
 	{
 	  if (which & FORMATS_PRINT)
-	    v[i]->print = f;
+            var_set_print_format (v[i], &f);
 	  if (which & FORMATS_WRITE)
-	    v[i]->write = f;
+            var_set_write_format (v[i], &f);
 	}
       free (v);
       v = NULL;
Index: src/language/dictionary/missing-values.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/missing-values.c,v
retrieving revision 1.12
diff -u -p -r1.12 missing-values.c
--- src/language/dictionary/missing-values.c	22 Nov 2006 04:24:02 -0000	1.12
+++ src/language/dictionary/missing-values.c	5 Dec 2006 06:36:42 -0000
@@ -59,32 +59,33 @@ cmd_missing_values (struct lexer *lexer,
         }
 
       for (i = 0; i < nv; i++)
-        mv_init (&v[i]->miss, v[i]->width);
+        var_clear_missing_values (v[i]);
 
       if (!lex_match (lexer, ')')) 
         {
           struct missing_values mv;
 
           for (i = 0; i < nv; i++)
-            if (v[i]->type != v[0]->type)
+            if (var_get_type (v[i]) != var_get_type (v[0]))
               {
-                const struct variable *n = v[0]->type == NUMERIC ? v[0] : v[i];
-                const struct variable *s = v[0]->type == NUMERIC ? v[i] : v[0];
+                const struct variable *n = var_is_numeric (v[0]) ? v[0] : v[i];
+                const struct variable *s = var_is_numeric (v[0]) ? v[i] : v[0];
                 msg (SE, _("Cannot mix numeric variables (e.g. %s) and "
                            "string variables (e.g. %s) within a single list."),
-                     n->name, s->name);
+                     var_get_name (n), var_get_name (s));
                 goto done;
               }
 
-          if (v[0]->type == NUMERIC) 
+          if (var_is_numeric (v[0])) 
             {
               mv_init (&mv, 0);
               while (!lex_match (lexer, ')'))
                 {
+                  enum fmt_type type = var_get_print_format (v[0])->type;
                   double x, y;
                   bool ok;
 
-                  if (!parse_num_range (lexer, &x, &y, &v[0]->print.type))
+                  if (!parse_num_range (lexer, &x, &y, &type))
                     goto done;
                   
                   ok = (x == y
@@ -132,17 +133,19 @@ cmd_missing_values (struct lexer *lexer,
           
           for (i = 0; i < nv; i++) 
             {
-              if (!mv_is_resizable (&mv, v[i]->width)) 
+              if (!mv_is_resizable (&mv, var_get_width (v[i]))) 
                 {
                   msg (SE, _("Missing values provided are too long to assign "
                              "to variable of width %d."),
-                       v[i]->width);
+                       var_get_width (v[i]));
                   deferred_errors = true;
                 }
               else 
                 {
-                  mv_copy (&v[i]->miss, &mv);
-                  mv_resize (&v[i]->miss, v[i]->width);
+                  struct missing_values tmp;
+                  mv_copy (&tmp, &mv);
+                  mv_resize (&tmp, var_get_width (v[i]));
+                  var_set_missing_values (v[i], &tmp);
                 }
             }
         }
Index: src/language/dictionary/modify-variables.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/modify-variables.c,v
retrieving revision 1.12
diff -u -p -r1.12 modify-variables.c
--- src/language/dictionary/modify-variables.c	11 Nov 2006 23:10:00 -0000	1.12
+++ src/language/dictionary/modify-variables.c	5 Dec 2006 06:36:43 -0000
@@ -357,7 +357,7 @@ compare_variables_given_ordering (const 
   if (ordering->positional)
     result = a->index < b->index ? -1 : a->index > b->index;
   else
-    result = strcasecmp (a->name, b->name);
+    result = strcasecmp (var_get_name (a), var_get_name (b));
   if (!ordering->forward)
     result = -result;
   return result;
@@ -430,7 +430,7 @@ validate_var_modification (const struct 
   for (i = 0; i < keep_cnt; i++) 
     {
       var_renaming[i].var = keep_vars[i];
-      strcpy (var_renaming[i].new_name, keep_vars[i]->name);
+      strcpy (var_renaming[i].new_name, var_get_name (keep_vars[i]));
     }
   
   /* Rename variables in var_renaming array. */
@@ -493,7 +493,7 @@ rearrange_dict (struct dictionary *d, co
      still exist, but we can still look them up by name. */
   rename_old_names = xnmalloc (vm->rename_cnt, sizeof *rename_old_names);
   for (i = 0; i < vm->rename_cnt; i++)
-    rename_old_names[i] = xstrdup (vm->rename_vars[i]->name);
+    rename_old_names[i] = xstrdup (var_get_name (vm->rename_vars[i]));
 
   /* Reorder and delete variables. */
   dict_reorder_vars (d, vm->reorder_vars, vm->reorder_cnt);
Index: src/language/dictionary/numeric.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/numeric.c,v
retrieving revision 1.16
diff -u -p -r1.16 numeric.c
--- src/language/dictionary/numeric.c	11 Nov 2006 23:10:00 -0000	1.16
+++ src/language/dictionary/numeric.c	5 Dec 2006 06:36:43 -0000
@@ -85,7 +85,7 @@ cmd_numeric (struct lexer *lexer, struct
 	  else
 	    {
 	      if (f.type != -1)
-		new_var->print = new_var->write = f;
+                var_set_both_formats (new_var, &f);
 	    }
 	}
 
@@ -152,7 +152,7 @@ cmd_string (struct lexer *lexer, struct 
 	  if (!new_var)
 	    msg (SE, _("There is already a variable named %s."), v[i]);
 	  else
-            new_var->print = new_var->write = f;
+            var_set_both_formats (new_var, &f);
 	}
 
       /* Clean up. */
Index: src/language/dictionary/split-file.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/split-file.c,v
retrieving revision 1.11
diff -u -p -r1.11 split-file.c
--- src/language/dictionary/split-file.c	11 Nov 2006 23:10:00 -0000	1.11
+++ src/language/dictionary/split-file.c	5 Dec 2006 06:36:43 -0000
@@ -92,14 +92,14 @@ output_split_file_values (const struct d
       struct variable *v = split[i];
       char temp_buf[80];
       const char *val_lab;
+      const struct fmt_spec *print = var_get_print_format (v);
 
-      assert (v->type == NUMERIC || v->type == ALPHA);
-      tab_text (t, 0, i + 1, TAB_LEFT | TAT_PRINTF, "%s", v->name);
+      tab_text (t, 0, i + 1, TAB_LEFT | TAT_PRINTF, "%s", var_get_name (v));
       
-      data_out (case_data (c, v->fv), &v->print, temp_buf);
-      
-      temp_buf[v->print.w] = 0;
-      tab_text (t, 1, i + 1, TAT_PRINTF, "%.*s", v->print.w, temp_buf);
+      data_out (case_data (c, v->fv), print, temp_buf);
+      temp_buf[print->w] = 0;
+
+      tab_text (t, 1, i + 1, TAT_PRINTF, "%.*s", print->w, temp_buf);
 
       val_lab = val_labs_find (v->val_labs, *case_data (c, v->fv));
       if (val_lab)
Index: src/language/dictionary/sys-file-info.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/sys-file-info.c,v
retrieving revision 1.16
diff -u -p -r1.16 sys-file-info.c
--- src/language/dictionary/sys-file-info.c	3 Dec 2006 22:16:45 -0000	1.16
+++ src/language/dictionary/sys-file-info.c	5 Dec 2006 06:36:43 -0000
@@ -130,7 +130,8 @@ cmd_sysfile_info (struct lexer *lexer, s
   {
     struct variable *weight_var = dict_get_weight (d);
     tab_text (t, 1, 7, TAB_LEFT,
-              weight_var != NULL ? weight_var->name : _("Not weighted.")); 
+              (weight_var != NULL
+               ? var_get_name (weight_var) : _("Not weighted."))); 
   }
   tab_text (t, 0, 8, TAB_LEFT, _("Mode:"));
   tab_text (t, 1, 8, TAB_LEFT | TAT_PRINTF,
@@ -258,7 +259,7 @@ cmd_display (struct lexer *lexer, struct
 	{
 	  size_t i, m;
 	  for (i = 0, m = n; i < n; i++)
-	    if (dict_class_from_id (vl[i]->name) != DC_SCRATCH)
+	    if (dict_class_from_id (var_get_name (vl[i])) != DC_SCRATCH)
 	      {
 		vl[i] = NULL;
 		m--;
@@ -409,10 +410,13 @@ display_variables (struct variable **vl,
 
 	  r = describe_variable (v, t, r, as);
 	} else {
-	  tab_text (t, 0, r, TAB_LEFT, v->name);
-	  if (as == AS_LABELS)
-	    tab_joint_text (t, 1, r, 2, r, TAB_LEFT,
-			    v->label == NULL ? "(no label)" : v->label);
+	  tab_text (t, 0, r, TAB_LEFT, var_get_name (v));
+	  if (as == AS_LABELS) 
+            {
+              const char *label = var_get_label (v);
+              tab_joint_text (t, 1, r, 2, r, TAB_LEFT,
+                              label != NULL ? "(no label)" : label); 
+            }
 	  if (as != AS_NAMES)
 	    {
 	      tab_text (t, pc, r, TAT_PRINTF, "%d", v->index + 1);
@@ -442,39 +446,40 @@ display_variables (struct variable **vl,
 static int 
 describe_variable (struct variable *v, struct tab_table *t, int r, int as)
 {
+  const struct fmt_spec *print = var_get_print_format (v);
+  const struct fmt_spec *write = var_get_write_format (v);
+
   /* Put the name, var label, and position into the first row. */
-  tab_text (t, 0, r, TAB_LEFT, v->name);
+  tab_text (t, 0, r, TAB_LEFT, var_get_name (v));
   tab_text (t, 3, r, TAT_PRINTF, "%d", v->index + 1);
 
-  if (as == AS_DICTIONARY && v->label)
+  if (as == AS_DICTIONARY && var_has_label (v)) 
     {
-      tab_joint_text (t, 1, r, 2, r, TAB_LEFT, v->label);
+      tab_joint_text (t, 1, r, 2, r, TAB_LEFT, var_get_label (v));
       r++;
     }
   
   /* Print/write format, or print and write formats. */
-  if (v->print.type == v->write.type
-      && v->print.w == v->write.w
-      && v->print.d == v->write.d)
+  if (fmt_equal (print, write))
     {
       char str[FMT_STRING_LEN_MAX + 1];
       tab_joint_text (t, 1, r, 2, r, TAB_LEFT | TAT_PRINTF, _("Format: %s"),
-		      fmt_to_string (&v->print, str));
+		      fmt_to_string (print, str));
       r++;
     }
   else
     {
       char str[FMT_STRING_LEN_MAX + 1];
       tab_joint_text (t, 1, r, 2, r, TAB_LEFT | TAT_PRINTF,
-		      _("Print Format: %s"), fmt_to_string (&v->print, str));
+		      _("Print Format: %s"), fmt_to_string (print, str));
       r++;
       tab_joint_text (t, 1, r, 2, r, TAB_LEFT | TAT_PRINTF,
-		      _("Write Format: %s"), fmt_to_string (&v->write, str));
+		      _("Write Format: %s"), fmt_to_string (write, str));
       r++;
     }
 
   /* Missing values if any. */
-  if (!mv_is_empty (&v->miss))
+  if (var_has_missing_values (v))
     {
       char buf[128];
       char *cp;
@@ -482,7 +487,8 @@ describe_variable (struct variable *v, s
       int cnt = 0;
       
       cp = stpcpy (buf, _("Missing Values: "));
-      mv_copy (&mv, &v->miss);
+      
+      mv_copy (&mv, var_get_missing_values (v));
       if (mv_has_range (&mv)) 
         {
           double x, y;
@@ -501,13 +507,13 @@ describe_variable (struct variable *v, s
           mv_pop_value (&mv, &value);
           if (cnt++ > 0)
             cp += sprintf (cp, "; ");
-          if (v->type == NUMERIC)
+          if (var_is_numeric (v))
             cp += sprintf (cp, "%g", value.f);
           else 
             {
               *cp++ = '"';
-	      memcpy (cp, value.s, v->width);
-	      cp += v->width;
+	      memcpy (cp, value.s, var_get_width (v));
+	      cp += var_get_width (v);
 	      *cp++ = '"';
               *cp = '\0';
             }
@@ -536,10 +542,10 @@ describe_variable (struct variable *v, s
         {
 	  char buf[128];
 
-	  if (v->type == ALPHA)
+	  if (var_is_alpha (v))
 	    {
-	      memcpy (buf, vl->value.s, v->width);
-	      buf[v->width] = 0;
+	      memcpy (buf, vl->value.s, var_get_width (v));
+	      buf[var_get_width (v)] = 0;
 	    }
 	  else
 	    sprintf (buf, "%g", vl->value.f);
Index: src/language/dictionary/value-labels.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/value-labels.c,v
retrieving revision 1.12
diff -u -p -r1.12 value-labels.c
--- src/language/dictionary/value-labels.c	1 Dec 2006 06:06:52 -0000	1.12
+++ src/language/dictionary/value-labels.c	5 Dec 2006 06:36:43 -0000
@@ -118,10 +118,10 @@ verify_val_labs (struct variable **vars,
     {
       struct variable *vp = vars[i];
 
-      if (vp->type == ALPHA && vp->width > MAX_SHORT_STRING)
+      if (var_is_long_string (vp))
 	{
 	  msg (SE, _("It is not possible to assign value labels to long "
-		     "string variables such as %s."), vp->name);
+		     "string variables such as %s."), var_get_name (vp));
 	  return 0;
 	}
     }
@@ -152,7 +152,7 @@ get_label (struct lexer *lexer, struct v
       size_t i;
 
       /* Set value. */
-      if (vars[0]->type == ALPHA)
+      if (var_is_alpha (vars[0]))
 	{
 	  if (lex_token (lexer) != T_STRING)
 	    {
